package com.jiuqi.sql.impl;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.jiuqi.sql.impl.DBaseFieldHeader;
import com.jiuqi.sql.impl.RW;
import com.jiuqi.util.OurGregorianCalendar;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

public class DBaseFileHeader {
  public static final int DBASE_FILE_VER_FLAG = 140;
  
  public static final int DBASE_FILE_VER_FLAG_SUPPORT_TEXT = 141;
  
  public static final String RESERVED3 = "DB936CN0";
  
  public static final int headLength = 68;
  
  public byte ver;
  
  public byte year;
  
  public byte month;
  
  public byte day;
  
  public long recCount;
  
  public int structDefLen;
  
  public int recLength;
  
  public byte[] reserved = new byte[16];
  
  public boolean hasIndex;
  
  public byte langDriver;
  
  public int reserved2;
  
  public byte[] reserved3 = new byte[8];
  
  public byte[] noCare3 = new byte[28];
  
  public void readFromStream(InputStream stream) throws IOException {
    this.ver = RW.read(stream);
    this.year = RW.read(stream);
    this.month = RW.read(stream);
    this.day = RW.read(stream);
    this.recCount = RW.readDWord(stream);
    this.structDefLen = RW.readWord(stream);
    this.recLength = RW.readWord(stream);
    stream.read(this.reserved);
    this.hasIndex = RW.readBoolean(stream);
    this.langDriver = RW.read(stream);
    this.reserved2 = RW.readWord(stream);
    stream.read(this.reserved3);
    stream.read(this.noCare3);
  }
  
  public void beginCreateFile() {
    this.ver = -115;
    long currentTime = System.currentTimeMillis();
    OurGregorianCalendar gc = new OurGregorianCalendar();
    gc.setTimeInMillisEx(currentTime);
    this.year = (byte)(gc.get(1) - 1900);
    this.month = (byte)(gc.get(2) + 1);
    this.day = (byte)gc.get(5);
    this.reserved3 = "DB936CN0".getBytes();
    this.recCount = 2147483647L;
  }
  
  public void writeToStream(OutputStream stream) throws IOException {
    RW.write(stream, this.ver);
    RW.write(stream, this.year);
    RW.write(stream, this.month);
    RW.write(stream, this.day);
    RW.writeDWord(stream, this.recCount);
    RW.writeWord(stream, this.structDefLen);
    RW.writeWord(stream, this.recLength);
    stream.write(this.reserved);
    RW.writeBoolean(stream, this.hasIndex);
    RW.write(stream, this.langDriver);
    RW.writeWord(stream, this.reserved2);
    stream.write(this.reserved3);
    stream.write(this.noCare3);
  }
  
  public void readFromBytes(byte[] buffer, int index) {
    this.ver = buffer[0];
    this.year = buffer[1];
    this.month = buffer[2];
    this.day = buffer[3];
    this.recCount = RW.readDWord(buffer, 4);
    this.structDefLen = RW.readWord(buffer, 8);
    this.recLength = RW.readWord(buffer, 10);
    System.arraycopy(buffer, 12, this.reserved, 0, this.reserved.length);
    this.hasIndex = RW.readBoolean(buffer, 27);
    this.langDriver = buffer[28];
    this.reserved2 = RW.readWord(buffer, 30);
    System.arraycopy(buffer, 32, this.reserved3, 0, this.reserved3.length);
    System.arraycopy(buffer, 40, this.noCare3, 0, this.noCare3.length);
  }
  
  public void writeToBytes(byte[] buffer, int index) {}
  
  public String toString() {
    StringBuffer result = new StringBuffer(super.toString());
    result.append(", ver:");
    result.append(this.ver);
    result.append(", year:");
    result.append(this.year);
    result.append(", month:");
    result.append(this.month);
    result.append(", day:");
    result.append(this.day);
    result.append(", recordCount:");
    result.append(this.recCount);
    result.append(", structDefLen:");
    result.append(this.structDefLen);
    result.append(", recLength:");
    result.append(this.recLength);
    result.append(", hasIndex:");
    result.append(this.hasIndex);
    result.append(", langDriver:");
    result.append(this.langDriver);
    return result.toString();
  }
  
  public static void main(String[] args) throws Exception {
    InputStream in = new FileInputStream("d:\\1.dbf");
    try {
      com.jiuqi.sql.impl.DBaseFileHeader dbf = new com.jiuqi.sql.impl.DBaseFileHeader();
      dbf.readFromStream(in);
      System.out.println(dbf);
      DBaseFieldHeader fh = new DBaseFieldHeader();
      for (int i = 0; i < (dbf.structDefLen - 69) / 50; i++) {
        fh.readFromStream(in);
        System.out.println(fh);
      } 
    } finally {
      in.close();
    } 
  }
}
